import * as fastify from 'fastify';
import { FastifyInstance } from 'fastify';
import { AsyncProvider, NodeProviderOptions, AsyncAdapter } from '@stenodb/node';
export { AsyncAdapter, AsyncProvider } from '@stenodb/node';
import { ClassEntity } from '@stenodb/utils';
export { ClassEntity } from '@stenodb/utils';
import { IOptions } from 'class-validator-jsonschema/build/options';

interface StenoOptions extends NodeProviderOptions {
    adapters: AsyncAdapter<any>[];
    entities?: ClassEntity<any>[];
    entityOptions?: IOptions;
}
declare module 'fastify' {
    interface FastifyInstance {
        steno: {
            get: <T>(name: string) => AsyncProvider<T> | undefined;
        };
    }
}

declare class StenoPlugin {
    #private;
    constructor(fastify: FastifyInstance, options: StenoOptions);
    static createInstance(fastify: FastifyInstance, options: StenoOptions, done: () => void): Promise<StenoPlugin>;
    registerDatabases(): Promise<void>;
    private registerEntities;
    private addSchema;
    private getDatabase;
}

declare const FastifySteno: fastify.FastifyPluginCallback<StenoOptions, fastify.RawServerDefault, fastify.FastifyTypeProviderDefault, fastify.FastifyBaseLogger>;

declare const _default: typeof StenoPlugin.createInstance;

export { FastifySteno, StenoOptions, _default as default };
